#ifndef TREE_H
#define TREE_H

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// A regular node with a left and right branch
struct Node {
  int data;
  struct Node *left, *right;
};
typedef struct Node Node;

// Represents a tree with a root node
struct Tree {
  Node *root;
};
typedef struct Tree Tree;

// Insert some data into the tree
int tree_insert(Tree *tree, int data);

// Remove some data from the tree
int tree_remove(Node **node, int data);

// Clear the tree (this wraps node_clear)
void tree_clear(Tree *tree);

// Recursively clear from a certain node
void node_clear(Node *node);

// Get the size of the tree
int tree_size(Node *node);

// Check if the tree contains some data
bool tree_contains(Node *node, int data);

// Print the tree in order
void tree_inorder(Node *node);

#endif // TREE_H